<!DOCTYPE html>
<html>

<head>
    <meta charset="utf-8">
    <link href="https://fonts.googleapis.com/css?family=Roboto:100,300,400,500,700,900" rel="stylesheet">
    <link href="https://cdn.jsdelivr.net/npm/@mdi/font@4.x/css/materialdesignicons.min.css" rel="stylesheet">
    <link href="https://cdn.jsdelivr.net/npm/vuetify@2.x/dist/vuetify.min.css" rel="stylesheet">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no">
    <title>WSI File Format And Performance Test</title>
</head>

<body>
    <div id="app">
        <v-app>
            <v-container v-for="reader in readers" :key="reader.name">
                <p class="font-weight-black">
                    {{ reader.name }} <v-chip>{{ reader.version }}</v-chip>
                </p>
                <v-simple-table>
                    <template v-slot:default>
                        <thead>
                            <tr>
                                <th class="text-left">
                                    <b>WSI</b>
                                </th>
                                <th class="text-left">
                                    <b>Format</b>
                                </th>
                                <th class="text-left">
                                    <b>Image Size</b>
                                </th>
                                <th class="text-left">
                                    <b>Tile Size</b>
                                </th>
                                <th class="text-left">
                                    <b>Pixel Size</b>
                                </th>
                                <th class="text-left">
                                    <b>Levels</b>
                                </th>
                                <th class="text-left">
                                    <b>Bits</b>
                                </th>
                                <th class="text-left">
                                    <b>Channels</b>
                                </th>
                                <th class="text-left">
                                    <b>Macro</b><br>Exists<br>Size<br>Data
                                </th>
                                <th class="text-left">
                                    <b>Label</b><br>Exists<br>Size<br>Data
                                </th>
                                <th class="text-left">
                                    <b>Thumbnail</b><br>Exists<br>Size<br>Data
                                </th>
                                <th class="text-left">
                                    <b>Random Region Data Test</b>
                                </th>
                                <th class="text-left">
                                    <b>Random Tile Data Test</b>
                                </th>
                                <th class="text-right">
                                    <b>Region Performance</b><br>MP/s<br>MB/s
                                </th>
                                <th class="text-right">
                                    <b>Tile Performance</b><br>MP/s<br>MB/s
                                </th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="slide in reader.slides" :key="slide.slide_info_ref.name">
                                <td>{{ slide.slide_info_ref.name }}</td>
                                <td>{{ slide.slide_info_ref.format.toUpperCase() }}</td>
                                <td>
                                    <v-icon v-if="slide.result.image_size" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.image_size==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.image_size==false" color="red">mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="slide.result.tile_size" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.tile_size==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.tile_size==false" color="red">mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="slide.result.pixel_size" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.pixel_size==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.pixel_size==false" color="red">mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="slide.result.levels" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.levels==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.levels==false" color="red">mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="slide.result.bits" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.bits==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.bits==false" color="red">mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="slide.result.channels" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.channels==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.channels==false" color="red">mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon
                                        v-if="slide.slide_info.macro_size!=null&&slide.slide_info_ref.slideinfo.macro_size!=null"
                                        color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.slide_info_ref.slideinfo.macro_size==null">mdi-minus-circle
                                    </v-icon>
                                    <v-icon
                                        v-if="slide.slide_info.macro_size==null&&slide.slide_info_ref.slideinfo.macro_size!=null"
                                        color="red">mdi-close-circle</v-icon><br>
                                    <v-icon v-if="slide.result.macro_size" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.macro_size==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.macro_size==false" color="red">mdi-close-circle</v-icon>
                                    <br>
                                    <v-icon v-if="slide.result.image_macro_mean" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.image_macro_mean==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.image_macro_mean==false" color="red">mdi-close-circle
                                    </v-icon>
                                </td>
                                <td>
                                    <v-icon
                                        v-if="slide.slide_info.label_size!=null&&slide.slide_info_ref.slideinfo.label_size!=null"
                                        color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.slide_info_ref.slideinfo.label_size==null">mdi-minus-circle
                                    </v-icon>
                                    <v-icon
                                        v-if="slide.slide_info.label_size==null&&slide.slide_info_ref.slideinfo.label_size!=null"
                                        color="red">mdi-close-circle</v-icon><br>
                                    <v-icon v-if="slide.result.label_size" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.label_size==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.label_size==false" color="red">mdi-close-circle</v-icon>
                                    <br>
                                    <v-icon v-if="slide.result.image_label_mean" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.image_label_mean==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.image_label_mean==false" color="red">mdi-close-circle
                                    </v-icon>
                                </td>
                                <td>
                                    <v-icon
                                        v-if="slide.slide_info.thumbnail_size!=null&&slide.slide_info_ref.slideinfo.thumbnail_size!=null"
                                        color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.slide_info_ref.slideinfo.thumbnail_size==null">mdi-minus-circle
                                    </v-icon>
                                    <v-icon
                                        v-if="slide.slide_info.thumbnail_size==null&&slide.slide_info_ref.slideinfo.thumbnail_size!=null"
                                        color="red">mdi-close-circle</v-icon><br>
                                    <v-icon v-if="slide.result.thumbnail_size" color="green">mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.thumbnail_size==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.thumbnail_size==false" color="red">mdi-close-circle
                                    </v-icon><br>
                                    <v-icon v-if="slide.result.image_thumbnail_mean" color="green">mdi-check-circle
                                    </v-icon>
                                    <v-icon v-if="slide.result.image_thumbnail_mean==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="slide.result.image_thumbnail_mean==false" color="red">mdi-close-circle
                                    </v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="checkBoolArray(slide.result.image_region_mean)==true" color="green">
                                        mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.image_region_mean==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="checkBoolArray(slide.result.image_region_mean)==false" color="red">
                                        mdi-close-circle</v-icon>
                                </td>
                                <td>
                                    <v-icon v-if="checkBoolArray(slide.result.image_tile_mean)==true" color="green">
                                        mdi-check-circle</v-icon>
                                    <v-icon v-if="slide.result.image_tile_mean==null">mdi-minus-circle</v-icon>
                                    <v-icon v-if="checkBoolArray(slide.result.image_tile_mean)==false" color="red">
                                        mdi-close-circle</v-icon>
                                </td>
                                <td class="text-right">
                                    {{ (Math.round(slide.result.region_performance / 100000) / 10).toFixed(1) }}<br>
                                    {{ (Math.round(slide.result.region_performance_io / 100) / 10).toFixed(1) }}
                                </td>
                                <td class="text-right">
                                    {{ (Math.round(slide.result.tile_performance / 100000) / 10).toFixed(1) }}<br>
                                    {{ (Math.round(slide.result.tile_performance_io / 100) / 10).toFixed(1) }}
                                </td>
                            </tr>
                        </tbody>
                    </template>
                </v-simple-table>
            </v-container>
        </v-app>
    </div>
</body>
<script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vue@2.x/dist/vue.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vuetify@2.x/dist/vuetify.js"></script>
<script>
    new Vue({
        el: '#app',
        vuetify: new Vuetify(),
        data() {
            return {
                slide_reader_list: null,
                slide_file_list: null,
                readers: []
            }
        },
        async created() {
            response = await axios.get("results/index.json")
            this.slide_reader_list = response.data.slide_reader_list.sort()
            this.slide_file_list = response.data.slide_file_list.sort()
            response = await axios.get("results/versions.json")
            let versions = response.data
            for (slide_reader of this.slide_reader_list) {
                let reader = {}
                reader.name = slide_reader
                reader.version = versions[slide_reader]
                reader.slides = []
                for (slide_file of this.slide_file_list) {
                    let slide = {}
                    let result_file_name = slide_reader + "-" + slide_file
                    let info_file_name = result_file_name.replace(".json", "-info.json")
                    response = await axios.get(slide_file)
                    slide.slide_info_ref = response.data
                    response = await axios.get("results/" + result_file_name)
                    slide.result = response.data
                    response = await axios.get("results/" + info_file_name)
                    slide.slide_info = response.data
                    reader.slides.push(slide)
                }
                this.readers.push(reader)
            }
        },
        methods: {
            checkBoolArray: function (boolArray) {
                if (boolArray == null) {
                    return null
                }
                return boolArray.every(element => element === true);
            }
        }
    })
</script>

</html>